### 1.引言

#### 1.1.文档概述

   本文档用于对基础链链码设计进行说明

### 2.链码数据规范

#### 2.1.响应参数

响应参数类型为 Response，返回结果中包含的字段为:

``` 
{
    "status": int 类型,
    "payload": []byte 类型
}
```

| 序号 | 字段    | 描述         | 备注                             |
| ---- | ------- | ------------ | -------------------------------- |
| 1    | status  | 调用是否成功 | 返回码：成功为200；失败为500     |
| 2    | payload | 响应结果     | 返回的结果的内容载体为[]byte数组 |

### 3.链码列表

#### 3.1.审计当事人录入

1.链码描述

录入审计当事人信息

2.调用场景

录入项目前需要先注册审计当事人

3.链码信息

链码方法名：registerAuditee

**请求数据：**

| 序号 | 字段名 | 字段            | 类型   | 必填       | 备注       |
| ---- | ------ | --------------- | ------ | ---------- | ---------- |
| 1    | 方法名 | registerAuditee | String | Y    | json字符串 |

参数列表：

| 序号 | 参数           | 类型   | 必填 | 备注 |
| ---- | -------------- | ------ | ---- | ---- |
| 1    | 审计当事人姓名 | String | Y    |      |

**响应数据：**

| 序号 | 字段名   | 类型   | 备注             |
| ---- | -------- | ------ | ---------------- |
| 1    | 响应结果 | string | 返回审计当事人ID |

#### 3.2.审计规则录入

1.链码描述

录入审计规则信息

2.调用场景

录入项目前需要先注册审计规则

3.链码信息

链码方法名：registerRules

**请求数据：**

| 序号 | 字段名 | 字段          | 类型   | 必填 | 备注   |
| ---- | ------ | ------------- | ------ | ---- | ------ |
| 1    | 方法名 | registerRules | String | Y    | 多参数 |

参数列表：

| 序号 | 参数           | 类型   | 必填 | 备注 |
| ---- | -------------- | ------ | ---- | ---- |
| 1    | 审计当事人姓名 | String | Y    |      |
| 2    | 时间规则       | String | Y    |      |
| 3    | 位置规则       | String | N    |      |
| 4    | 物体识别规则   | String | N    |      |
| 5    | 人脸识别规则   | String | N    |      |

**响应数据：**

| 序号 | 字段名   | 类型   | 备注           |
| ---- | -------- | ------ | -------------- |
| 1    | 响应结果 | string | 返回审计规则ID |

#### 3.3.项目录入

1.链码描述

录入项目信息

2.调用场景

录入需要审计业务的项目

3.链码信息

链码方法名：registerProject

**请求数据：**

| 序号 | 字段名 | 字段            | 类型   | 必填 | 备注 |
| ---- | ------ | --------------- | ------ | ---- | ---- |
| 1    | 方法名 | registerProject | String | Y    |      |

参数列表：

| 序号 | 参数         | 类型   | 必填 | 备注                                                   |
| ---- | ------------ | ------ | ---- | ------------------------------------------------------ |
| 1    | 名称         | String | Y    |                                                        |
| 2    | 描述信息     | String | Y    |                                                        |
| 3    | 审计当事人ID | Uint32 | N    | 可以有多个审计当事人，与审计规则ID交替出现且个数相同   |
| 4    | 审计规则ID   | Uint32 | N    | 可以有多个审计规则ID，与审计当事人ID交替出现且个数相同 |

**响应数据：**

| 序号 | 字段名   | 类型   | 备注           |
| ---- | -------- | ------ | -------------- |
| 1    | 响应结果 | Uint32 | 返回审计项目ID |

#### 3.4.新增审计事件

1.链码描述

验证并录入审计事件

2.调用场景

需要审计业务的项目审计当事人需要在规定的时间地点打卡录入审计事件

3.链码信息

链码方法名：addEvent

**请求数据：**

| 序号 | 字段名 | 字段     | 类型   | 必填 | 备注 |
| ---- | ------ | -------- | ------ | ---- | ---- |
| 1    | 方法名 | addEvent | String | Y    |      |

参数列表：

| 序号 | 参数         | 类型   | 必填 | 备注 |
| ---- | ------------ | ------ | ---- | ---- |
| 1    | 审计当事人ID | Uint32 | Y    |      |
| 2    | 项目ID       | Uint32 | Y    |      |
| 3    | 事件         | String | N    |      |
| 4    | 地点         | String | N    |      |
| 5    | 物体照片     | String | N    |      |
| 6    | 人脸照片     | String | N    |      |

**响应数据：**

| 序号 | 字段名   | 类型    | 备注                   |
| ---- | -------- | ------- | ---------------------- |
| 1    | 响应结果 | Uint256 | 返回审计结果，成功为OK |

#### 3.5.合约维护人员查询

1 链码描述

 获取所有的合约维护人员

2.调用场景

需要查询确认审计合约是否部署成功，以及需要查询合约维护人员信息时调用

3.链码信息

链码方法名：getMaintainers

**请求数据：**

| 序号 | 字段名 | 字段           | 类型   | 必填 | 备注       |
| ---- | ------ | -------------- | ------ | ---- | ---------- |
| 1    | 方法名 | getMaintainers | String | Y    | json字符串 |

**响应数据：**

| 序号 | 字段名   | 类型   | 备注                 |
| ---- | -------- | ------ | -------------------- |
| 1    | 响应结果 | String | 返回合约维护人员列表 |

合约维护人员信息：

| 序号 | 字段名 | 字段 | 类型   | 备注 |
| ---- | ------ | ---- | ------ | ---- |
| 1    | 名称   | name | String |      |
| 2    | 编号   | ID   | Uint32 |      |

#### 3.6.审计当事人查询

1.链码描述

根据ID获取审计当事人信息

2.调用场景

注册审计当事人后可用于查询注册信息

3.链码信息

链码方法名：getAuditee

**请求数据：**

| 序号 | 字段名 | 字段       | 类型   | 必填 | 备注       |
| ---- | ------ | ---------- | ------ | ---- | ---------- |
| 1    | 方法名 | getAuditee | String | Y    | json字符串 |

参数列表：

| 序号 | 参数         | 类型       | 必填 | 备注 |
| ---- | ------------ | ---------- | ---- | ---- |
| 1    | 审计当事人ID | json字符串 | Y    |      |

**响应数据：**

| 序号 | 字段名   | 类型 | 备注                 |
| ---- | -------- | ---- | -------------------- |
| 1    | 响应结果 | List | 返回合约维护人员列表 |

合约维护人员信息：

| 序号 | 字段名         | 字段 | 类型   | 备注 |
| ---- | -------------- | ---- | ------ | ---- |
| 1    | 审计当事人姓名 | name | String |      |
| 2    | 审计当事人编号 | ID   | Uint32 |      |

#### 3.7.审计规则查询

1.链码描述

根据ID获取审计规则信息

2.调用场景

注册审计规则后查询已经注册的审计规则

3.链码信息

链码方法名：getRules

**请求数据：**

| 序号 | 字段名 | 字段     | 类型   | 必填 | 备注       |
| ---- | ------ | -------- | ------ | ---- | ---------- |
| 1    | 方法名 | getRules | String | Y    | json字符串 |

参数列表：

| 序号 | 参数       | 类型   | 必填 | 备注 |
| ---- | ---------- | ------ | ---- | ---- |
| 1    | 审计规则ID | Uint32 | Y    |      |

**响应数据：**

| 序号 | 字段名   | 类型   | 备注                 |
| ---- | -------- | ------ | -------------------- |
| 1    | 响应结果 | String | 返回合约维护人员列表 |

审计规则信息：

| 序号 | 字段名       | 字段     | 类型   | 备注       |
| ---- | ------------ | -------- | ------ | ---------- |
| 1    | 操作符       | Operator | String |            |
| 2    | 规则信息详情 | Rules    | Uint32 | json字符串 |
| 3    | ID           | ID       | Uint32 |            |

规则信息详情：

| 序号 | 字段名         | 字段            | 类型   | 备注 |
| ---- | -------------- | --------------- | ------ | ---- |
| 1    | 名称           | Time            | string |      |
| 2    | 规则信息详情   | Location        | Uint32 |      |
| 3    | ID             | ObjectRecognize | Uint32 |      |
| 4    | 人脸识别规则ID | FaceRecognize   | Uint32 |      |

#### 3.8.审计项目查询

1.链码描述

根据ID获取审计项目信息

2.调用场景

注册审计项目后查询已经注册的审计项目

3.链码信息

链码方法名：getProject

**请求数据：**

| 序号 | 字段名 | 字段       | 类型   | 必填 | 备注       |
| ---- | ------ | ---------- | ------ | ---- | ---------- |
| 1    | 方法名 | getProject | String | Y    | json字符串 |

参数列表：

| 序号 | 参数       | 类型   | 必填 | 备注 |
| ---- | ---------- | ------ | ---- | ---- |
| 1    | 审计项目ID | Uint32 | Y    |      |

**响应数据：**

| 序号 | 字段名   | 类型   | 备注       |
| ---- | -------- | ------ | ---------- |
| 1    | 响应结果 | String | json字符串 |

审计项目信息：

| 序号 | 字段名                         | 字段            | 类型   | 备注       |
| ---- | ------------------------------ | --------------- | ------ | ---------- |
| 1    | 项目名称                       | Name            | String |            |
| 2    | 规则信息详情                   | Rules           | Uint32 |            |
| 3    | ID                             | Description     | String |            |
| 4    | 项目包含的审计当事人及规则信息 | AuditeeRulesMap | String | json字符串 |

项目包含的审计当事人及规则信息Map：

| 序号 | 字段名         | 字段   | 类型   | 备注       |
| ---- | -------------- | ------ | ------ | ---------- |
| 1    | 审计当事人信息 | Key    | String | json字符串 |
| 2    | Location       | Uint32 | String | json字符串 |

#### 3.9.审计事件查询

1.链码描述

根据审计当事人ID、项目ID以及规则ID，查询满足条件的所有审计事件

2.调用场景

审计事件注册后查询审计事件信息

3.链码信息

链码方法名：queryEvents

**请求数据：**

| 序号 | 字段名 | 字段        | 类型   | 必填 | 备注       |
| ---- | ------ | ----------- | ------ | ---- | ---------- |
| 1    | 方法名 | queryEvents | String | Y    | json字符串 |

参数列表：

| 序号 | 参数         | 类型   | 必填 | 备注 |
| ---- | ------------ | ------ | ---- | ---- |
| 1    | 审计当事人ID | Uint32 | Y    |      |
| 2    | 项目ID       | Uint32 | Y    |      |

**响应数据：**

| 序号 | 字段名   | 类型   | 备注       |
| ---- | -------- | ------ | ---------- |
| 1    | 响应结果 | String | json字符串 |

审计项目信息：

| 序号 | 字段名                         | 字段    | 类型   | 备注       |
| ---- | ------------------------------ | ------- | ------ | ---------- |
| 1    | 项目名称                       | ID      | String |            |
| 2    | Uint32                         | Auditee | String | json字符串 |
| 3    | Description                    | Project | String | json字符串 |
| 4    | 项目包含的审计当事人及规则信息 | Rule    | String | json字符串 |

